Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm	(revision 34921)
@@ -2868,4 +3836,229 @@
         PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
     },
+    21 => { #30
+        Name => 'LevelIndicator',
+        PrintConv => '$val == 90 ? "n/a" : $val',
+        PrintConvInv => '$val eq "n/a" ? 90 : $val',
+    },
+);
+
+# auto-exposure information for the K-01 (ref PH)
+%Image::ExifTool::Pentax::AEInfo2 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Auto-exposure information for the K-01.',
+    # instead of /8, should these be PentaxEv(), as in CameraSettings? - PH
+    2 => {
+        Name => 'AEExposureTime',
+        Notes => 'val = 24 * 2**((32-raw)/8)',
+        ValueConv => '24*exp(-($val-32)*log(2)/8)',
+        ValueConvInv => '-log($val/24)*8/log(2)+32',
+        PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    3 => {
+        Name => 'AEAperture',
+        Notes => 'val = 2**((raw-68)/16)',
+        ValueConv => 'exp(($val-68)*log(2)/16)',
+        ValueConvInv => 'log($val)*16/log(2)+68',
+        PrintConv => 'sprintf("%.1f",$val)',
+        PrintConvInv => '$val',
+    },
+    4 => {
+        Name => 'AE_ISO',
+        Notes => 'val = 100 * 2**((raw-32)/8)',
+        ValueConv => '100*exp(($val-32)*log(2)/8)',
+        ValueConvInv => 'log($val/100)*8/log(2)+32',
+        PrintConv => 'int($val + 0.5)',
+        PrintConvInv => '$val',
+    },
+    5 => {
+        Name => 'AEXv',
+        # this is the negative of exposure compensation, not including bracketing
+        Notes => 'val = (raw-64)/8',
+        ValueConv => '($val-64)/8',
+        ValueConvInv => '$val * 8 + 64',
+    },
+    6 => {
+        Name => 'AEBXv',
+        # this is the negative of auto exposure bracketing compensation
+        Format => 'int8s',
+        Notes => 'val = raw / 8',
+        ValueConv => '$val / 8',
+        ValueConvInv => '$val * 8',
+    },
+    8 => {
+        Name => 'AEError',
+        Format => 'int8s',
+        # this is usually zero except in M exposure mode, but it can be non-zero
+        # in other modes (eg. if you hit an aperture limit in Tv mode)
+        ValueConv => '-($val-64)/8', # (negate to make overexposed positive)
+        ValueConvInv => '-$val * 8 + 64',
+    },
+    11 => {
+        Name => 'AEApertureSteps',
+        Notes => q{
+            number of steps the aperture has been stopped down from wide open.  There
+            are roughly 8 steps per F-stop, but it varies slightly by lens
+        },
+        PrintConv => '$val == 255 ? "n/a" : $val',
+        PrintConvInv => '$val eq "n/a" ? 255 : $val',
+    },
+    15 => {
+        Name => 'SceneMode',
+        PrintConvColumns => 2,
+        PrintConv => {
+            0 => 'Off',
+            1 => 'HDR',
+            4 => 'Auto PICT',
+            5 => 'Portrait',
+            6 => 'Landscape',
+            7 => 'Macro',
+            8 => 'Sport',
+            9 => 'Night Scene Portrait',
+            10 => 'No Flash',
+            11 => 'Night Scene',
+            12 => 'Surf & Snow',
+            14 => 'Sunset',
+            15 => 'Kids',
+            16 => 'Pet',
+            17 => 'Candlelight',
+            18 => 'Museum',
+            20 => 'Food',
+            21 => 'Stage Lighting',
+            22 => 'Night Snap',
+            25 => 'Night Scene HDR',
+            26 => 'Blue Sky',
+            27 => 'Forest',
+            29 => 'Backlight Silhouette',
+        },
+    },
+    16 => {
+        Name => 'AEMaxAperture',
+        Notes => 'val = 2**((raw-68)/16)',
+        ValueConv => 'exp(($val-68)*log(2)/16)',
+        ValueConvInv => 'log($val)*16/log(2)+68',
+        PrintConv => 'sprintf("%.1f",$val)',
+        PrintConvInv => '$val',
+    },
+    17 => {
+        Name => 'AEMaxAperture2',
+        Notes => 'val = 2**((raw-68)/16)',
+        ValueConv => 'exp(($val-68)*log(2)/16)',
+        ValueConvInv => 'log($val)*16/log(2)+68',
+        PrintConv => 'sprintf("%.1f",$val)',
+        PrintConvInv => '$val',
+    },
+    18 => {
+        Name => 'AEMinAperture',
+        Notes => 'val = 2**((raw-68)/16)',
+        ValueConv => 'exp(($val-68)*log(2)/16)',
+        ValueConvInv => 'log($val)*16/log(2)+68',
+        PrintConv => 'sprintf("%.0f",$val)',
+        PrintConvInv => '$val',
+    },
+    19 => {
+        Name => 'AEMinExposureTime',
+        Notes => 'val = 24 * 2**((32-raw)/8)',
+        ValueConv => '24*exp(-($val-32)*log(2)/8)',
+        ValueConvInv => '-log($val/24)*8/log(2)+32',
+        PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+);
+
+# auto-exposure information for the K-30 (ref PH)
+%Image::ExifTool::Pentax::AEInfo3 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Auto-exposure information for the K-3, K-30, K-50 and K-500.',
+    # instead of /8, should these be PentaxEv(), as in CameraSettings? - PH
+    16 => {
+        Name => 'AEExposureTime',
+        Notes => 'val = 24 * 2**((32-raw)/8)',
+        ValueConv => '24*exp(-($val-32)*log(2)/8)',
+        ValueConvInv => '-log($val/24)*8/log(2)+32',
+        PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    17 => {
+        Name => 'AEAperture',
+        Notes => 'val = 2**((raw-68)/16)',
+        ValueConv => 'exp(($val-68)*log(2)/16)',
+        ValueConvInv => 'log($val)*16/log(2)+68',
+        PrintConv => 'sprintf("%.1f",$val)',
+        PrintConvInv => '$val',
+    },
+    18 => {
+        Name => 'AE_ISO',
+        Notes => 'val = 100 * 2**((raw-32)/8)',
+        ValueConv => '100*exp(($val-32)*log(2)/8)',
+        ValueConvInv => 'log($val/100)*8/log(2)+32',
+        PrintConv => 'int($val + 0.5)',
+        PrintConvInv => '$val',
+    },
+    28 => {
+        Name => 'AEMaxAperture',
+        Notes => 'val = 2**((raw-68)/16)',
+        ValueConv => 'exp(($val-68)*log(2)/16)',
+        ValueConvInv => 'log($val)*16/log(2)+68',
+        PrintConv => 'sprintf("%.1f",$val)',
+        PrintConvInv => '$val',
+    },
+    29 => {
+        Name => 'AEMaxAperture2',
+        Notes => 'val = 2**((raw-68)/16)',
+        ValueConv => 'exp(($val-68)*log(2)/16)',
+        ValueConvInv => 'log($val)*16/log(2)+68',
+        PrintConv => 'sprintf("%.1f",$val)',
+        PrintConvInv => '$val',
+    },
+    30 => {
+        Name => 'AEMinAperture',
+        Notes => 'val = 2**((raw-68)/16)',
+        ValueConv => 'exp(($val-68)*log(2)/16)',
+        ValueConvInv => 'log($val)*16/log(2)+68',
+        PrintConv => 'sprintf("%.0f",$val)',
+        PrintConvInv => '$val',
+    },
+    31 => {
+        Name => 'AEMinExposureTime',
+        Notes => 'val = 24 * 2**((32-raw)/8)',
+        ValueConv => '24*exp(-($val-32)*log(2)/8)',
+        ValueConvInv => '-log($val/24)*8/log(2)+32',
+        PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+);
+
+# unknown auto-exposure information (Q, Q10)
+%Image::ExifTool::Pentax::AEInfoUnknown = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+);
+
+# lens type
+%Image::ExifTool::Pentax::LensRec = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => q{
+        This record stores the LensType, plus one or two unknown bytes for some
+        models.
+    },
+    0 => {
+        Name => 'LensType',
+        Format => 'int8u[2]',
+        Priority => 0,
+        ValueConvInv => '$val=~s/\.\d+$//; $val',
+        PrintConv => \%pentaxLensTypes,
+        SeparateTable => 1,
+    },
+    3 => { #PH
+        Name => 'ExtenderStatus',
+        Notes => 'not valid if a non-AF lens is used',
+        PrintConv => { 0 => 'Not attached', 1 => 'Attached' },
+    },
+    # this is a binaryData table because some cameras add an extra
+    # byte or two here (typically zeros)...
 );
 
@@ -2880,4 +4073,5 @@
         Format => 'int8u[2]',
         Priority => 0,
+        ValueConvInv => '$val=~s/\.\d+$//; $val',
         PrintConv => \%pentaxLensTypes,
         SeparateTable => 1,
@@ -2906,4 +4100,13 @@
             return "$v[0] $v[1]";
         },
+        # just fill in the missing bits/bytes with zeros...
+        ValueConvInv => q{
+            my @v = split(' ',$val);
+            return undef unless @v == 2;
+            $v[2] = ($v[1] >> 8) & 0xff;
+            $v[3] = $v[1] & 0xff;
+            $v[1] = 0;
+            return "@v";
+        },
         PrintConv => \%pentaxLensTypes,
         SeparateTable => 1,
@@ -2932,4 +4135,13 @@
             return "$v[0] $v[1]";
         },
+        # just fill in the missing bits/bytes with zeros...
+        ValueConvInv => q{
+            my @v = split(' ',$val);
+            return undef unless @v == 2;
+            $v[2] = ($v[1] >> 8) & 0xff;
+            $v[3] = $v[1] & 0xff;
+            $v[1] = 0;
+            return "@v";
+        },
         PrintConv => \%pentaxLensTypes,
         SeparateTable => 1,
@@ -2958,8 +4170,53 @@
             return "$v[0] $v[1]";
         },
+        # just fill in the missing bits/bytes with zeros...
+        ValueConvInv => q{
+            my @v = split(' ',$val);
+            return undef unless @v == 2;
+            $v[2] = ($v[1] >> 8) & 0xff;
+            $v[3] = $v[1] & 0xff;
+            $v[1] = 0;
+            return "@v";
+        },
         PrintConv => \%pentaxLensTypes,
         SeparateTable => 1,
     },
     12 => {
+        Name => 'LensData',
+        Format => 'undef[18]',
+        Condition => '$$self{NewLensData} = 1', # not really a condition, just used to set flag
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::LensData' },
+    },
+);
+
+# lens information for K-01, K-30, K-50, K-500, K-3, K-3II, K-S1 (ref PH)
+%Image::ExifTool::Pentax::LensInfo5 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    IS_SUBDIR => [ 15 ],
+    NOTES => 'Pentax lens information structure for the K-01 and newer models.',
+    1 => {
+        Name => 'LensType',
+        Format => 'int8u[5]',
+        Priority => 0,
+        ValueConv => q{
+            my @v = split(' ',$val);
+            $v[0] &= 0x0f;
+            $v[1] = $v[3] * 256 + $v[4]; # (always high byte first)
+            return "$v[0] $v[1]";
+        },
+        # just fill in the missing bits/bytes with zeros...
+        ValueConvInv => q{
+            my @v = split(' ',$val);
+            return undef unless @v == 2;
+            $v[3] = ($v[1] >> 8) & 0xff;
+            $v[4] = $v[1] & 0xff;
+            $v[1] = $v[2] = 0;
+            return "@v";
+        },
+        PrintConv => \%pentaxLensTypes,
+        SeparateTable => 1,
+    },
+    15 => {
         Name => 'LensData',
         Format => 'undef[17]',
@@ -2972,4 +4229,5 @@
     %binaryDataAttrs,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    DATAMEMBER => [ 12.1 ],
     NOTES => q{
         Pentax lens data information.  Some of these tags require interesting binary
@@ -2980,25 +4238,28 @@
     0.1 => { #JD
         Name => 'AutoAperture',
+        Condition => 'not $$self{NewLensData}',
+        Notes => 'not valid for the K-r, K-5 or K-5II', #29
         Mask => 0x01,
-        PrintConv => {
-            0 => 'On',
-            1 => 'Off',
-        },
+        PrintConv => { 0 => 'On', 1 => 'Off' },
     },
     0.2 => { #JD
         Name => 'MinAperture',
+        Condition => 'not $$self{NewLensData}',
+        Notes => 'not valid for the K-r, K-5 or K-5II', #29
         Mask => 0x06,
         PrintConv => {
-            0x00 => 22,
-            0x02 => 32,
-            0x04 => 45,
-            0x06 => 16,
+            0 => 22,
+            1 => 32,
+            2 => 45,
+            3 => 16,
         },
     },
     0.3 => { #JD
         Name => 'LensFStops',
+        Condition => 'not $$self{NewLensData}',
+        Notes => 'not valid for the K-r, K-5 or K-5II', #29
         Mask => 0x70,
-        ValueConv => '5 + (($val >> 4) ^ 0x07) / 2',
-        ValueConvInv => '((($val - 5) * 2) ^ 0x07) << 4',
+        ValueConv => '5 + ($val ^ 0x07) / 2',
+        ValueConvInv => '(($val - 5) * 2) ^ 0x07',
     },
     # 1-16 look like Lens Codes LC0-LC15, ref patent 5617173 and 5999753 [+notes by PH]
@@ -3011,21 +4272,54 @@
         %lensCode,
     },
-    3 => { # LC2 = distance data
-        Name => 'LC2',
-        %lensCode,
-        # FocusRange decoding needs more testing with various lenses - PH
-        TestName => 'FocusRange',
-        TestPrintConv => q{
-            my @v;
-            my $lsb = $val & 0x07;
-            my $msb = $val >> 3;
-            my $ls2 = $lsb ^ 0x07;
-            $ls2 ^= 0x01 if $ls2 & 0x02;
-            $ls2 ^= 0x03 if $ls2 & 0x04;
-            foreach ($ls2, $ls2+1) {
-                push(@v,'inf'), next if $_ > 7;
-                push @v, sprintf("%.2f m", 2 ** ($msb / 4) * 0.18 * ($_ + 4) / 16);
-            }
-            return join ' - ', @v;
+    # LC2 = distance data
+    3 => { #29
+        Name => 'MinFocusDistance',
+        Notes => 'minimum focus distance for the lens',
+        Mask => 0xf8,
+        PrintConv => {
+            0 => '0.13-0.19 m', # (plus K or M lenses)
+            1 => '0.20-0.24 m',
+            2 => '0.25-0.28 m',
+            3 => '0.28-0.30 m',
+            4 => '0.35-0.38 m',
+            5 => '0.40-0.45 m',
+            6 => '0.49-0.50 m', # (plus many Sigma lenses)
+            7 => '0.6 m',       #PH (NC)
+            8 => '0.7 m',       # (plus Sigma 55-200)
+            9 => '0.8-0.9 m',   #PH (NC) Tokina 28-70/2.6-2.8
+            10 => '1.0 m',      # (plus Sigma 70 macro)
+            11 => '1.1-1.2 m',
+            12 => '1.4-1.5 m',
+            13 => '1.5 m',      # Sigma 70-300/4-5.6 macro
+            14 => '2.0 m',
+            15 => '2.0-2.1 m',  #PH (NC)
+            16 => '2.1 m',      # Sigma 135-400 APO & DG: 2.0-2.2m
+            17 => '2.2-2.9 m',  #PH (NC)
+            18 => '3.0 m',      # Sigma 50-500 : 1.0-3.0m depending on the focal length
+                                 ## 50mm, 100mm => 1.0m
+                                 ## 200mm       => 1.1m
+                                 ## 300mm       => 1.5m
+                                 ## 400mm       => 2.2m
+                                 ## 500mm       => 3.0m
+            19 => '4-5 m',      #PH (NC)
+            20 => '5.6 m',      # Pentax DA 560
+            # To check: Sigma 120-400 OS: MFD 1.5m
+            # To check: Sigma 150-500 OS: MFD 2.2m
+            # To check: Sigma 50-500 has MFD 50-180cm
+            # 0xd0 - seen for the Sigma 4.5mm F2.8 EX DC HSM Circular Fisheye (ref PH)
+        },
+    },
+    3.1 => { #29
+        Name => 'FocusRangeIndex',
+        Mask => 0x07,
+        PrintConv => {
+            7 => '0 (very close)',
+            6 => '1 (close)',
+            4 => '2',
+            5 => '3',
+            1 => '4',
+            0 => '5',
+            2 => '6 (far)',
+            3 => '7 (very far)',
         },
     },
@@ -3034,13 +4328,13 @@
         %lensCode,
     },
-    5 => { # LC4 = abberation correction, near distance data
+    5 => { # LC4 = aberration correction, near distance data
         Name => 'LC4',
         %lensCode,
     },
-    6 => { # LC5 = light color abberation correction data
+    6 => { # LC5 = light color aberration correction data
         Name => 'LC5',
         %lensCode,
     },
-    7 => { # LC6 = open abberation data
+    7 => { # LC6 = open aberration data
         Name => 'LC6',
         %lensCode,
@@ -3050,7 +4344,9 @@
         %lensCode,
     },
-    9 => { # LC8 = focal length data
-        Name => 'FocalLength',
+    9 => [{ # LC8 = focal length data
+        Name => 'LensFocalLength',
+        Notes => 'focal length of lens alone, without adapter', #PH
         Priority => 0,
+        Condition => '$$self{Model} !~ /645Z/', #PH (doesn't work for 645Z)
         ValueConv => '10*($val>>2) * 4**(($val&0x03)-2)', #JD
         ValueConvInv => q{
@@ -3061,11 +4357,14 @@
         PrintConv => 'sprintf("%.1f mm", $val)',
         PrintConvInv => '$val=~s/\s*mm//; $val',
-    },
+    },{
+        Name => 'LC8',
+        %lensCode,
+    }],
     # the following aperture values change with focal length
     10 => { # LC9 = nominal AVmin/AVmax data (open/closed aperture values)
         Name => 'NominalMaxAperture',
         Mask => 0xf0,
-        ValueConv => '2**(($val>>4)/4)', #JD
-        ValueConvInv => '4*log($val)/log(2) << 4',
+        ValueConv => '2**($val/4)', #JD
+        ValueConvInv => '4*log($val)/log(2)',
         PrintConv => 'sprintf("%.1f", $val)',
         PrintConvInv => '$val',
@@ -3087,10 +4386,19 @@
         %lensCode,
     },
+    12.1 => {
+        Name => 'NewLensDataHook',
+        Hidden => 1,
+        Hook => '$varSize += 1 if $$self{NewLensData}',
+        RawConv => 'undef',
+    },
     13 => { # LC12 = mv1 AVminsif data
         Name => 'LC12',
+        Notes => "ID's 13-16 are offset by 1 for the K-r, K-5 and K-5II", #29
         %lensCode,
     },
+    # 14 - related to live view for K-5 (normally 3, but 1 or 5 in LV mode)
     14.1 => { # LC13 = AVmin (open aperture value) [MaxAperture=(2**((AVmin-1)/32))]
         Name => 'MaxAperture',
+        Condition => '$$self{Model} ne "K-5"',
         Notes => 'effective wide open aperture for current focal length',
         Mask => 0x7f, # (not sure what the high bit indicates)
@@ -3307,4 +4615,5 @@
         # I've also seen: 0x42 (K2000), 0xf2 (K-7,K-r,K-5), 0x12,0x22 (K-x) - PH
         PrintConv => {
+            1 => 'Camera Battery', #PH (NC, GR III)
             2 => 'Body Battery',
             3 => 'Grip Battery',
@@ -3315,24 +4624,24 @@
         {
             Name => 'BodyBatteryState',
-            Condition => '$$self{Model} =~ /(\*ist|K100D|K200D|K10D|GX10|K20D|GX20)\b/',
+            Condition => '$$self{Model} =~ /(\*ist|K100D|K200D|K10D|GX10|K20D|GX20|GX-1[LS]?)\b/',
             Notes => '*istD, K100D, K200D, K10D and K20D',
             Mask => 0xf0,
             PrintConv => { #19
-                 0x10 => 'Empty or Missing',
-                 0x20 => 'Almost Empty',
-                 0x30 => 'Running Low',
-                 0x40 => 'Full',
+                 1 => 'Empty or Missing',
+                 2 => 'Almost Empty',
+                 3 => 'Running Low',
+                 4 => 'Full',
             },
         },{
             Name => 'BodyBatteryState',
-            Condition => '$$self{Model} =~ /(K-5|K-7|K-r|K-x|645D)\b/',
-            Notes => 'K-5, K-7, K-r, K-x and 645D',
+            Condition => '$$self{Model} !~ /(K110D|K2000|K-m)\b/',
+            Notes => 'other models except the K110D, K2000 and K-m',
             Mask => 0xf0,
             PrintConv => {
-                 0x10 => 'Empty or Missing',
-                 0x20 => 'Almost Empty',
-                 0x30 => 'Running Low',
-                 0x40 => 'Close to Full',
-                 0x50 => 'Full',
+                 1 => 'Empty or Missing',
+                 2 => 'Almost Empty',
+                 3 => 'Running Low',
+                 4 => 'Close to Full',
+                 5 => 'Full',
             },
         },{
@@ -3340,6 +4649,4 @@
             Notes => 'decoding unknown for other models',
             Mask => 0xf0,
-            ValueConv => '$val >> 4',
-            ValueConvInv => '$val << 4',
         },
     ],
@@ -3351,8 +4658,8 @@
             Mask => 0x0f,
             PrintConv => { #19
-                 0x01 => 'Empty or Missing',
-                 0x02 => 'Almost Empty',
-                 0x03 => 'Running Low',
-                 0x04 => 'Full',
+                 1 => 'Empty or Missing',
+                 2 => 'Almost Empty',
+                 3 => 'Running Low',
+                 4 => 'Full',
             },
         },{
@@ -3379,9 +4686,9 @@
             Name => 'BodyBatteryADNoLoad',
             Description => 'Body Battery A/D No Load',
-            Condition => '$$self{Model} =~ /(\*ist|K100D|K200D)\b/',
+            Condition => '$$self{Model} =~ /(\*ist|K100D|K200D|GX-1[LS]?)\b/',
         },
         {
             Name => 'BodyBatteryVoltage1', # (static?)
-            Condition => '$$self{Model} =~ /(K-5|K-7|K-r|K-x|645D)\b/',
+            Condition => '$$self{Model} !~ /(K100D|K110D|K2000|K-m|Q\d*)\b/',
             Format => 'int16u',
             ValueConv => '$val / 100',
@@ -3389,5 +4696,5 @@
             PrintConv => 'sprintf("%.2f V", $val)',
             PrintConvInv => '$val =~ s/\s*V$//',
-            # For my K-5:          Min (0%) Max (100%) Meas
+            # For my K-5:          Min (0%) Max (100%) At Meas
             # BodyBatteryVoltage1  6.24 V   7.75 V     7.66 V
             # BodyBatteryVoltage2  5.98 V   7.43 V     7.34 V
@@ -3418,9 +4725,9 @@
             Name => 'GripBatteryADNoLoad',
             Description => 'Grip Battery A/D No Load',
-            Condition => '$$self{Model} =~ /(\*ist|K10D|GX10|K20D|GX20)\b/',
+            Condition => '$$self{Model} =~ /(\*ist|K10D|GX10|K20D|GX20|GX-1[LS]?)\b/',
         },
         {
             Name => 'BodyBatteryVoltage2', # (less than BodyBatteryVoltage1 -- under load?)
-            Condition => '$$self{Model} =~ /(K-5|K-7|K-r|K-x|645D)\b/',
+            Condition => '$$self{Model} !~ /(K100D|K110D|K2000|K-m|Q\d*)\b/',
             Format => 'int16u',
             ValueConv => '$val / 100',
@@ -3472,4 +4779,5 @@
         PrintConvColumns => 2,
         PrintConv => {
+            0 => '(none)',
             0x07ff => 'All',
             0x0777 => 'Central 9 points',
@@ -3533,7 +4841,9 @@
     0x0b => { #JD
         Name => 'AFPointsInFocus',
+        Condition => '$$self{Model} !~ /K-[13]\b/',
         Notes => q{
-            may report two points in focus even though a single AFPoint has been
-            selected, in which case the selected AFPoint is the first reported
+            models other than the K-1 and K-3.  May report two points in focus even
+            though a single AFPoint has been selected, in which case the selected
+            AFPoint is the first reported
         },
         PrintConvColumns => 2,
@@ -3562,4 +4872,35 @@
         },
     },
+    0x1fd => {
+        Name => 'AFHold',
+        Notes => 'decoded only for the K-3 II',
+        Condition => '$$self{Model} eq "PENTAX K-3 II"',
+        PrintConv => { 0 => 'Off', 1 => 'Short', 2 => 'Medium', 3 => 'Long' },
+    },
+);
+
+# Kelvin white balance information (ref 28, topic 4834)
+%Image::ExifTool::Pentax::KelvinWB = (
+    %binaryDataAttrs,
+    FORMAT => 'int16u',
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'White balance Blue/Red gains as a function of color temperature.',
+    1  => { Name => 'KelvinWB_Daylight', %kelvinWB },
+    5  => { Name => 'KelvinWB_01', %kelvinWB },
+    9  => { Name => 'KelvinWB_02', %kelvinWB },
+    13 => { Name => 'KelvinWB_03', %kelvinWB },
+    17 => { Name => 'KelvinWB_04', %kelvinWB },
+    21 => { Name => 'KelvinWB_05', %kelvinWB },
+    25 => { Name => 'KelvinWB_06', %kelvinWB },
+    29 => { Name => 'KelvinWB_07', %kelvinWB },
+    33 => { Name => 'KelvinWB_08', %kelvinWB },
+    37 => { Name => 'KelvinWB_09', %kelvinWB },
+    41 => { Name => 'KelvinWB_10', %kelvinWB },
+    45 => { Name => 'KelvinWB_11', %kelvinWB },
+    49 => { Name => 'KelvinWB_12', %kelvinWB },
+    53 => { Name => 'KelvinWB_13', %kelvinWB },
+    57 => { Name => 'KelvinWB_14', %kelvinWB },
+    61 => { Name => 'KelvinWB_15', %kelvinWB },
+    65 => { Name => 'KelvinWB_16', %kelvinWB },
 );
 
@@ -3574,5 +4915,5 @@
     },
     17 => {
-        Name => 'WBShiftMG',
+        Name => 'WBShiftGM',
         Notes => 'positive is a shift toward green',
     },
@@ -3606,5 +4947,5 @@
     1 => { # (presumably this is from an orientation sensor)
         Name => 'CameraOrientation',
-        Condition => '$$self{Model} =~ /K-[^m]/',
+        Condition => '$$self{Model} =~ /K-(5|7|r|x)\b/',
         Notes => 'K-5, K-7, K-r and K-x',
         PrintHex => 1,
@@ -3970,5 +5311,5 @@
         The parameters associated with each type of digital filter are unique, and
         these settings are also extracted with the DigitalFilter tag.  Information
-        is not extracted for filters that are "Off" unless the Unknown option is
+        is not extracted for filters that are "Off" unless the L<Unknown|../ExifTool.html#Unknown> option is
         used.
     },
@@ -4008,5 +5349,8 @@
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     FORMAT => 'int8s',
-    NOTES => 'Tags decoded from the electronic level information.',
+    NOTES => q{
+        Tags decoded from the electronic level information for the K-5.  May not be
+        valid for other models.
+    },
     0 => {
         Name => 'LevelOrientation',
@@ -4014,4 +5358,5 @@
         PrintHex => 0,
         PrintConv => {
+            0 => 'n/a', #PH (NC, GR III)
             1 => 'Horizontal (normal)',
             2 => 'Rotate 180',
@@ -4030,13 +5375,13 @@
         Mask => 0xf0,
         PrintConv => {
-            0x00 => 'Off',
-            0x20 => 'Composition Adjust',
-            0xa0 => 'Composition Adjust + Horizon Correction',
-            0xc0 => 'Horizon Correction',
+            0 => 'Off',
+            2 => 'Composition Adjust',
+            10 => 'Composition Adjust + Horizon Correction',
+            12 => 'Horizon Correction',
         },
     },
     1 => {
         Name => 'RollAngle',
-        Notes => 'degrees of clockwise camera rotation',
+        Notes => 'converted to degrees of clockwise camera rotation',
         ValueConv => '-$val / 2',
         ValueConvInv => '-$val * 2',
@@ -4044,5 +5389,5 @@
     2 => {
         Name => 'PitchAngle',
-        Notes => 'degrees of upward camera tilt',
+        Notes => 'converted to degrees of upward camera tilt',
         ValueConv => '-$val / 2',
         ValueConvInv => '-$val * 2',
@@ -4070,12 +5415,135 @@
 );
 
-# temperature information for the K5 - PH
-%Image::ExifTool::Pentax::TempInfoK5 = (
+# white balance RGGB levels (ref 28)
+%Image::ExifTool::Pentax::WBLevels = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    # 0 - 11 (number of entries in this table)
+    # 1 - 0
+    2 => {
+        Name => 'WB_RGGBLevelsDaylight',
+        Format => 'int16u[4]',
+    },
+    # 10 - 1
+    11 => {
+        Name => 'WB_RGGBLevelsShade',
+        Format => 'int16u[4]',
+    },
+    # 19 - 2
+    20 => {
+        Name => 'WB_RGGBLevelsCloudy',
+        Format => 'int16u[4]',
+    },
+    # 28 - 3
+    29 => {
+        Name => 'WB_RGGBLevelsTungsten',
+        Format => 'int16u[4]',
+    },
+    # 37 - 4
+    38 => {
+        Name => 'WB_RGGBLevelsFluorescentD',
+        Format => 'int16u[4]',
+    },
+    # 46 - 5
+    47 => {
+        Name => 'WB_RGGBLevelsFluorescentN',
+        Format => 'int16u[4]',
+    },
+    # 55 - 6
+    56 => {
+        Name => 'WB_RGGBLevelsFluorescentW',
+        Format => 'int16u[4]',
+    },
+    # 64 - 7
+    65 => {
+        Name => 'WB_RGGBLevelsFlash',
+        Format => 'int16u[4]',
+    },
+    # 73 - 8
+    74 => {
+        Name => 'WB_RGGBLevelsFluorescentL',
+        Format => 'int16u[4]',
+    },
+    # 82 - 0xfe
+    83 => {
+        Name => 'WB_RGGBLevelsUnknown',
+        Format => 'int16u[4]',
+        Unknown => 1,
+    },
+    # 91 - 0xff
+    92 => {
+        Name => 'WB_RGGBLevelsUserSelected',
+        Format => 'int16u[4]',
+    },
+);
+
+# lens information for Penax Q (ref PH)
+# (306 bytes long, I wonder if this contains vignetting information too?)
+%Image::ExifTool::Pentax::LensInfoQ = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'More lens information stored by the Pentax Q.',
+    0x0c => {
+        Name => 'LensModel',
+        Format => 'string[30]',
+    },
+    0x2a => {
+        Name => 'LensInfo',
+        Format => 'string[20]',
+        ValueConv => '$val=~s/mm/mm /; $val',
+        ValueConvInv => '$val=~tr/ //d; $val',
+    }
+);
+
+# Pixel shift information for the K-3II (ref PH)
+%Image::ExifTool::Pentax::PixelShiftInfo = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Pixel shift information stored by the K-3 II.',
+    0x00 => {
+        Name => 'PixelShiftResolution',
+        PrintConv => { 0 => 'Off', 1 => 'On' },
+    },
+);
+
+# AF point information for the K-1 (ref 29)
+%Image::ExifTool::Pentax::AFPointInfo = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'AF point information written by the K-1.',
+    # 0 - int16u: 1 (version?)
+    2 => {
+        Name => 'NumAFPoints',
+        Format => 'int16u',
+    },
+    4 => {
+        Name => 'AFPointsInFocus',
+        Condition => '$$self{Model} =~ /K-1\b/',
+        Format => 'int8u[9]',
+        PrintConv => 'Image::ExifTool::Pentax::DecodeAFPoints($val,33,2,0x02)',
+    },
+    4.1 => {
+        Name => 'AFPointsSelected',
+        Condition => '$$self{Model} =~ /K-1\b/',
+        Format => 'int8u[9]',
+        PrintConv => 'Image::ExifTool::Pentax::DecodeAFPoints($val,33,2,0x03)',
+    },
+    4.2 => {
+        Name => 'AFPointsSpecial',
+        Condition => '$$self{Model} =~ /K-1\b/',
+        Format => 'int8u[9]',
+        PrintConv => 'Image::ExifTool::Pentax::DecodeAFPoints($val,33,2,0x03,0x03)',
+    },
+);
+
+# temperature information for some models - PH
+%Image::ExifTool::Pentax::TempInfo = (
     %binaryDataAttrs,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     NOTES => q{
         A number of additional temperature readings are extracted from this 256-byte
-        binary-data block in images from the K-5.  It is not currently known where
-        the corresponding temperature sensors are located in the camera.
+        binary-data block in images from models such as the K-01, K-3, K-5, K-50 and
+        K-500.  It is currently not known where the corresponding temperature
+        sensors are located in the camera.
     },
     # (it would be nice to know where these temperature sensors are located,
@@ -4085,5 +5553,5 @@
     #  more quickly than CameraTemperature when shooting video.)
     0x0c => {
-        Name => 'CameraTemperature2',
+        Name => 'SensorTemperature', #forum6677 (was CameraTemperature2)
         Format => 'int16s',
         ValueConv => '$val / 10',
@@ -4093,5 +5561,5 @@
     },
     0x0e => {
-        Name => 'CameraTemperature3',
+        Name => 'SensorTemperature2', #forum6677 (was CameraTemperature3)
         Format => 'int16s',
         ValueConv => '$val / 10',
@@ -4102,4 +5570,5 @@
     0x14 => {
         Name => 'CameraTemperature4',
+        Condition => '$$self{Model} =~ /K-5\b/',
         Format => 'int16s',
         PrintConv => '"$val C"',
@@ -4108,8 +5577,10 @@
     0x16 => { # usually the same as CameraTemperature4, but not always
         Name => 'CameraTemperature5',
+        Condition => '$$self{Model} =~ /K-5\b/',
         Format => 'int16s',
         PrintConv => '"$val C"',
         PrintConvInv => '$val=~s/ ?c$//i; $val',
     },
+    # 0x18,0x1a,0x1c,0x1e = int16u[4] BlackPoint - PH
 );
 
@@ -4221,4 +5692,6 @@
             1600 => 1600, #PH
             3200 => 3200, #PH
+            65534 => 'Auto 2', #PH (Q-S1 MOV) [how is this different from 65535?]
+            65535 => 'Auto', #PH (K-S1 MOV)
         },
     },
